Author : Evensgn 
Blog Link : http://www.cnblogs.com/JoeFan/
Article Link : http://www.cnblogs.com/JoeFan/p/4338003.html
 

游戏介绍

Lights Out (关灯)是一款据说在20世纪90年代就已经被设计出的小游戏,游戏的玩法十分简单。

首先,给定一个 n 行 m 列的矩形方格阵,每个格子上都有一盏灯。

初始时,有些灯是开着的,有些灯是关着的。

玩家每次进行一次操作,选中一盏灯,点击一下它,就会将它和与它相邻的灯的状态改变,即开着的灯变为关闭,关着的灯变为开启。

最后的目的是关闭所有的灯。

这里给出一个网页版的链接:关灯。

还有博客园一位博友DIY的一个类似的游戏,蓝色拼图。这个蓝色拼图与 Lights Out 实质上相同,只是初始状态固定了是所有的灯都是开启的。

Lights Out 的游戏规则就是这样简单,然而到了后面的几关,方格增多,情况复杂,人工找出解法对于我来说是十分困难的。

因此,我们考虑用程序求解这个游戏。

求解方法

首先我们要将这个游戏的过程转化为数学模型。

显然地,对于一个方格,会影响到它的方格只有它本身和与它相邻的 4 个方格(对于边界的方格来说,相邻的方格不足 4 个)。

并且很容易发现,每一个方格我们要么不点击,要么点击 1 次,因为点击一个方格两次及以上是没有任何意义的。每点击两次就相当于没有点击。

对于方格 i ,我们用 0 表示不点击它,用 1 表示点击它,记作 Si 。

每盏灯的状态只有开或者关,我们用 0 和 1 表示方格 i 状态,方格 i 的初始状态记为 Mi 。

可以看出,每盏灯 i 的最终状态只与 Mi + Si + Sk1 + Sk2 + .... + Skp  (k1 ... kp 是枚举与 i 相邻的所有方格)的奇偶性有关。

既然只与奇偶性有关,我们就可以用异或运算来表示它。

也就是说,对于每盏灯 i ,我们都可以得到一个方程       Mi xor Si xor Sk1 xor Sk2 xor ... xor Skp = 0 。

等式右边的 0 表示最后每盏灯的状态都是关闭的。

这个方程其实也就等价于        Si xor Sk1 xor Sk2 xor ... xor Skp = Mi 。

我们得到了 Tot 个这样的方程(Tot 是灯的数量,即 Tot = n * m),共有 Tot 个未知数(即 Tot 个 Si),就是一个异或方程组。

由于游戏给定的初始状态一定有解,所以我们是一定可以求出这个异或方程组的一组解的。

那么下面的问题就是:怎样求解异或方程组?

显然,我们要使用高斯消元来求异或方程组的解。

这个过程与使用高斯消元求解普通的线性方程组相似(如果不了解高斯消元可以看一下Wikipedia-高斯消去法),只是每次在一个方程中消去一个未知数的时候,不是将这个方程乘上一个系数后与另一个方程相减,而是将这个方程的系数与另一个方程的系数进行异或运算,两个方程右边的数也要一起进行异或。

这样就可以求出 Lights Out 的解了。

代码如下,因为代码非常简单所以没有添加注释:

#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <cmath> using namespace std; const int MaxL = 10 + 5, MaxN = 100 + 5;
const int Dx[5] = {0, 0, 1, -1}, Dy[5] = {1, -1, 0, 0}; int n, m, Tot;
int A[MaxN][MaxN], Map[MaxL][MaxL], Ans[MaxL][MaxL]; inline bool Inside(int x, int y)
{
if (x < 0 || x >= n) return false;
if (y < 0 || y >= m) return false;
return true;
} inline int Get_Index(int x, int y)
{
return x * m + y + 1;
} struct Pos
{
int x, y;
}; inline Pos Get_Pos(int Num)
{
Pos ret;
ret.x = (Num - 1) / m;
ret.y = ((Num % m - 1) + m) % m;
return ret;
} void Get_Equation(int x, int y)
{
int Id, Id2, xx, yy;
Id = Get_Index(x, y);
for (int i = 1; i <= Tot; ++i) A[Id][i] = 0;
A[Id][Tot + 1] = Map[x][y];
A[Id][Id] = 1;
for (int k = 0; k < 4; ++k)
{
xx = x + Dx[k]; yy = y + Dy[k];
if (!Inside(xx, yy)) continue;
Id2 = Get_Index(xx, yy);
A[Id][Id2] = 1;
}
} inline void Swap(int p, int q)
{
int Temp;
for (int i = 1; i <= Tot + 1; ++i)
{
Temp = A[p][i];
A[p][i] = A[q][i];
A[q][i] = Temp;
}
} void Gauss()
{
int Tj;
for (int i = 1; i <= Tot; ++i)
{
Tj = i;
for (int j = i + 1; j <= Tot; ++j)
{
if (A[Tj][i] == 0 && A[j][i] == 1)
{
Tj = j;
break;
}
}
if (A[Tj][i] == 0) continue;
if (Tj != i) Swap(Tj, i);
for (int j = i + 1; j <= Tot; ++j)
{
if (A[j][i] == 0) continue;
for (int k = i; k <= Tot + 1; ++k)
A[j][k] ^= A[i][k];
}
} Pos Pi;
for (int i = Tot; i >= 1; --i)
{
Pi = Get_Pos(i);
Ans[Pi.x][Pi.y] = A[i][Tot + 1];
for (int j = i - 1; j >= 1; --j)
if (A[j][i]) A[j][Tot + 1] ^= A[i][Tot + 1];
}
} int main()
{
scanf("%d%d", &n, &m);
Tot = n * m;
for (int i = 0; i < n; ++i)
for (int j = 0; j < m; ++j)
scanf("%1d", &Map[i][j]);
for (int i = 0; i < n; ++i)
for (int j = 0; j < m; ++j)
Get_Equation(i, j);
Gauss(); printf("Solution:\n");
for (int i = 0; i < n; ++i)
{
for (int j = 0; j < m; ++j)
printf("%d", Ans[i][j]);
printf("\n");
}
return 0;
}

  

小游戏 Lights Out (关灯) 的求解 —— 异或方程组的更多相关文章

  1. 高斯消元法求解异或方程组: cojs.tk 539.//BZOJ 1770 牛棚的灯

    高斯消元求解异或方程组: 比较不错的一篇文章:http://blog.sina.com.cn/s/blog_51cea4040100g7hl.html cojs.tk  539. 牛棚的灯 ★★☆   ...

  2. 【poj1830-开关问题】高斯消元求解异或方程组

    第一道高斯消元题目~ 题目:有N个相同的开关,每个开关都与某些开关有着联系,每当你打开或者关闭某个开关的时候,其他的与此开关相关联的开关也会相应地发生变化,即这些相联系的开关的状态如果原来为开就变为关 ...

  3. 【poj1222-又一道开关问题】高斯消元求解异或方程组

    题意:给出一个5*6的图,每个灯泡有一个初始状态,1表示亮,0表示灭.每对一个灯泡操作时,会影响周围的灯泡改变亮灭,问如何操作可以使得所有灯泡都关掉. 题解: 这题和上一题几乎完全一样..就是要输出解 ...

  4. BZOJ.1923.[SDOI2010]外星千足虫(高斯消元 异或方程组 bitset)

    题目链接 m个方程,n个未知量,求解异或方程组. 复杂度比较高,需要借助bitset压位. 感觉自己以前写的(异或)高斯消元是假的..而且黄学长的写法都不需要回代. //1100kb 324ms #i ...

  5. 自制Unity小游戏TankHero-2D(4)关卡+小地图图标+碰撞条件分析

    自制Unity小游戏TankHero-2D(4)关卡+小地图图标+碰撞条件分析 我在做这样一个坦克游戏,是仿照(http://game.kid.qq.com/a/20140221/028931.htm ...

  6. [BZOJ1659][Usaco2006 Mar]Lights Out 关灯

    [BZOJ1659][Usaco2006 Mar]Lights Out 关灯 试题描述 奶牛们喜欢在黑暗中睡觉.每天晚上,他们的牲口棚有L(3<=L<=50)盏灯,他们想让亮着的灯尽可能的 ...

  7. jQuery实践-网页版2048小游戏

    ▓▓▓▓▓▓ 大致介绍 看了一个实现网页版2048小游戏的视频,觉得能做出自己以前喜欢玩的小游戏很有意思便自己动手试了试,真正的验证了这句话-不要以为你以为的就是你以为的,看视频时觉得看懂了,会写了, ...

  8. 拼图小游戏之计算后样式与CSS动画的冲突

    先说结论: 前几天写了几个非常简单的移动端小游戏,其中一个拼图游戏让我郁闷了一段时间.因为要获取每张图片的位置,用`<style>`标签写的样式,直接获取计算后样式再用来交换位置,结果就悲 ...

  9. 推荐10款超级有趣的HTML5小游戏

    HTML5的发展速度比任何人的都想像都要更快.更加强大有效的和专业的解决方案已经被开发......甚至在游戏世界中!这里跟大家分享有10款超级趣味的HTML5游戏,希望大家能够喜欢! Kern Typ ...

随机推荐

  1. 标准差(standard deviation)和标准误差(standard error)你能解释清楚吗?

    by:ysuncn(欢迎转载,请注明原创信息) 什么是标准差(standard deviation)呢?依据国际标准化组织(ISO)的定义:标准差σ是方差σ2的正平方根:而方差是随机变量期望的二次偏差 ...

  2. cookie记录浏览记录

    cookie记录浏览记录 HashMap也是我们使用非常多的Collection,它是基于哈希表的 Map 接口的实现,以key-value的形式存在.在HashMap中,key-value总是会当做 ...

  3. 利用mysql中的SQL_CALC_FOUND_ROWS 来实现group by后的记录数统计

    最近正在做一个显示消息的列表页,列表页中需要根据一个字段来分组显示.并且需要一个分页的效果. 大家也知道group by 后的数据是每一组一行记录,统计分组后的总的记录数又不能用count,所以SQL ...

  4. webapi 接口规则

    [HttpPost] [AuthorizeFilter] public HttpResponseMessage DeleteStudentInfo([FromBody] object value) { ...

  5. .net+easyui系列--搜索框

    <input id="ss" style="width: 320px"> </input> <div id="mm&qu ...

  6. json 是什么

    怎么学习一个知识? 首先要提出几个问题,目前认为json是个什么,json是谁创造的,为什么而出现的,但是目前仅有很长时间之前别人直接告诉我的,json用来存数据的,对于使用也忘记的差不多了,所以现在 ...

  7. 爆牙齿的 Web 标准面试题 【转藏】

    <!DOCTYPE html> <html lang="zh-CN"><head> <meta http-equiv="cont ...

  8. java反射的应用+mybatis+spring动态生成数据库表

    最近接触了一个类似于代码生成工具的活.思路是,通过java的反射机制得到类的字段和字段类型, 从而可以创建一个map集合存储表名(由类名决定的特殊结构字符串),表字段(由类变量确定),表字段类型(由变 ...

  9. Servie学习总结

    一.什么是Service Service是一个应用程序组件,它是安卓实现程序后台运行的一个解决方案. 二.分类 服务有两种类别started.bound.但是一个服务类所要继承的类是一样的,都是Ser ...

  10. js - 多个函数动态加载

    //动态添加物流锁的IEMI列表. function createLi() { var r = '<s:property value="#session.locks"/> ...